@tailwind base;
@tailwind components;
@tailwind utilities;

@layer base {
  /*
   * Variables
   */
  :root {
    /* colors */
    --ag-colors--success: theme('colors.success');
    --ag-colors--error: theme('colors.error');

    /* measure */
    --ag-base--measure: theme('maxWidth.measure');
    /* color */
    --ag-base--text-color: theme('colors.gray.900');
    /* background-color */
    --ag-base--bg-color: theme('colors.gray.200');

    /* padding-{left,right} */
    --ag-base--px: theme('spacing.2');
    --ag-base--px-sm: theme('spacing.6');
    --ag-base--px-md: theme('spacing.6');
    --ag-base--px-lg: theme('spacing.8');
    --ag-base--px-xl: theme('spacing.16');

    /* padding-{top,bottom} */
    --ag-base--py: theme('spacing.16');
    --ag-base--py-sm: theme('spacing.16');
    --ag-base--py-md: theme('spacing.24');
    --ag-base--py-lg: theme('spacing.32');
    --ag-base--py-xl: theme('spacing.32');

    /* height {navbar,main} */
    --ag-navbar--h: theme('spacing.16');
    --ag-main-atf--h: calc(100vh - var(--ag-navbar--h));
  }

  /*
   * Text
   */
  html,
  body {
    color: var(--ag-base--text-color);
    background-color: var(--ag-base--bg-color);
    @apply font-sans leading-normal;
  }
}

@layer components {
  /*
   * Scrollbars
   */
  .a-scrollbar-cs {
    scrollbar-width: none;
  }
  .a-scrollbar-cs::-webkit-scrollbar {
    display: none;
  }

  @screen sm {
    /* prettier-ignore */
    .a-scrollbar-cs {
      --a-scrollbar-cs--track--def-bg-color: transparent;
      --a-scrollbar-cs--thumb--def-bg-color: theme('colors.gray.300');
      --a-scrollbar-cs--thumb--def-border: theme('borderRadius.DEFAULT');

      --scrollbar-cs--track--bg-color: var(--a-scrollbar-cs--track--bg-color, var(--a-scrollbar-cs--track--def-bg-color));
      --scrollbar-cs--thumb--bg-color: var(--a-scrollbar-cs--thumb--bg-color, var(--a-scrollbar-cs--thumb--def-bg-color));

      scrollbar-width: thin;
      scrollbar-color: var(--scrollbar-cs--thumb--bg-color) var(--scrollbar-cs--track--bg-color);
    }
    .a-scrollbar-cs::-webkit-scrollbar {
      display: block;
      width: theme('spacing.1');
    }
    .a-scrollbar-cs::-webkit-scrollbar-track {
      background-color: var(--scrollbar-cs--track--bg-color);
    }
    /* prettier-ignore */
    .a-scrollbar-cs::-webkit-scrollbar-thumb {
      background-color: var(--scrollbar-cs--thumb--bg-color);
      border-radius: var(--a-scrollbar-cs--thumb--border, var(--a-scrollbar-cs--thumb--def-border));
    }
  }
}

@layer utilities {
  /*
   * Animations
   */
  @variants responsive {
    /* animation-duration */
    .animation-duration-75 {
      animation-duration: 75ms;
    }
    .animation-duration-100 {
      animation-duration: 100ms;
    }
    .animation-duration-150 {
      animation-duration: 150ms;
    }
    .animation-duration-200 {
      animation-duration: 200ms;
    }
    .animation-duration-300 {
      animation-duration: 300ms;
    }
    .animation-duration-500 {
      animation-duration: 500ms;
    }
    .animation-duration-700 {
      animation-duration: 700ms;
    }
    .animation-duration-1000 {
      animation-duration: 1000ms;
    }

    /*
    * animation-timing-function
    * See:
    * - https://tailwindcss.com/docs/transition-timing-function
    * - https://easings.net
    */
    .animation-ease-linear {
      animation-timing-function: linear;
    }
    .animation-ease-in {
      animation-timing-function: cubic-bezier(0.4, 0, 1, 1);
    }
    .animation-ease-out {
      animation-timing-function: cubic-bezier(0, 0, 0.2, 1);
    }
    .animation-ease-in-out {
      animation-timing-function: cubic-bezier(0.4, 0, 0.2, 1);
    }

    /* animation-direction */
    .animation-normal {
      animation-direction: normal;
    }
    .animation-reverse {
      animation-direction: reverse;
    }
    .animation-alternate {
      animation-direction: alternate;
    }
    .animation-alternate-reverse {
      animation-direction: alternate-reverse;
    }

    /* animation-fill-mode */
    .animation-fill-none {
      animation-fill-mode: none;
    }
    .animation-fill-forwards {
      animation-fill-mode: forwards;
    }
    .animation-fill-backwards {
      animation-fill-mode: backwards;
    }
    .animation-fill-both {
      animation-fill-mode: both;
    }
  }

  /*
   * Effects
   */
  @keyframes fade-in {
    0% {
      opacity: 0;
    }
    100% {
      opacity: 1;
    }
  }

  @variants responsive {
    .a-fade-in-fxs {
      animation-name: fade-in;
    }
  }

  @keyframes fade-in-quint {
    0% {
      opacity: 0;
    }
    50% {
      opacity: 1;
    }
    100% {
      opacity: 1;
    }
  }

  @variants responsive {
    .a-fade-in-quint-fxs {
      animation-name: fade-in-quint;
    }
  }

  @keyframes slide-in-bottom {
    0% {
      transform: translateY(100vh);
    }
    100% {
      transform: translateY(0);
    }
  }

  @variants responsive {
    .a-slide-in-bottom-fxs {
      animation-name: slide-in-bottom;
    }
  }
}
